// ͂ޓ̗ v1.3

// ̗ւW[BW[ϐƂ
//   x       ... ̗ւ̒SXW
//   y       ... ̗ւ̒SYW
//   z       ... ̗ւ̒SZW
//   r       ... ̗ւ̊Oa
//   r_inner ... ̗ւ̓a
//   ang     ... ̗ւ̉]px
//   a_ang   ... ̗ւ̉]鑬x
//   v_xy    ... ̗ւXYʏł̑
//   v_z     ... ̗ւZ̑
//   v_ang   ... ̗ւXYʏł̐is
//   life    ... ̗ւ̎
// B
#module ring x, y, z, r, r_inner, ang, a_ang, v_xy, v_z, v_ang, life
#const DIV_NUM   14     // O̕
#const LIFE_MAX  100    // ̏l
#const GRAVITY   -2.0   // d͉xij
#const A_ANG_MAX 0.1    // ]xl
#const A_ANG_MIN 0.005  // ]xŏl
#const REPEL     -0.9   // Wi-1`0j
#const ANG_WIDTH ( PI * 2.0 ) / ( DIV_NUM + 3 ) // ̗ւ̂̕ipxj
//
// ̗ւ̐ij
#modinit int _x, int _y, int _z, double _r, int _v_xy, double _v_ang
	x = _x : y = _y : z = _z    // S̍W
	r = _r                      // ւ̊Oa
	r_inner = 0.8 * r           // ւ̓a

	v_xy  = _v_xy
	v_z   = 0.0
	v_ang = _v_ang
	ang   = 0.0
	a_ang = A_ANG_MAX
	life  = LIFE_MAX
	return
//
// O𓮂
#modfunc move_ring
	// d͂ɂZ̑̕ύX
	v_z += GRAVITY
	// ]
	ang += a_ang
	// ړ
	x += cos( v_ang ) * v_xy
	y += sin( v_ang ) * v_xy
	z += v_z
	// ͂ޏ
	if ( z < r ) : gosub *bound
	// ̌
	life--
	return life <= 0
//
// ʂ͂ޏ
*bound
	// WƑx̕ύX
	z    = r * 2.0 - z
	v_z *= REPEL
	// px̌
	a_ang = limitf( a_ang - 0.006, A_ANG_MIN, A_ANG_MAX )
	// gЂƂ
	newmod mod_ripple@, ripple, x, y
	// p[eBN̐
	t = PI * rnd( 60 ) / 30.0
	repeat 5
		newmod mod_particle@, particle, x, y, t
		t += PI * ( 1.0 + rnd(3) ) / 5.0
	loop
	return
//
// O`
#modfunc draw_ring
	gosub *calc_alpha           // At@uhlZo
	gmode GMODE_ADD, , , alpha  // Z[hŕ`
	d3setlocal x, y, z, cos( v_ang ) * cos( ang ), -cos( v_ang ) * sin( ang ),-sin( v_ang ), sin( v_ang ) * cos( ang ), -sin( v_ang ) * sin( ang ), cos( v_ang ), -sin( ang ), -cos( ang ), 0
	gosub *draw_myself

	return
//
// ʂ̋`
#modfunc draw_mirror
	gosub *calc_alpha               // At@uhlZo
	gmode GMODE_ADD, , , alpha / 4  // Z[hŕ`i{41̔Zj
	d3setlocal x, y, -z, cos( v_ang ) * cos( ang ), -cos( v_ang ) * sin( ang ), -sin( v_ang ), sin( v_ang ) * cos( ang ), -sin( v_ang ) * sin( ang ), cos( v_ang ), sin( ang ), cos(ang), 0
	gosub *draw_myself
	return
//
// At@uh̃uhi0`200jvZ
// iflimitɂāÃOt̂悤ɋ܂
// uh
// b    QQQQQ
// b  ^          _
// b^              _
// \\\\\\\\\
*calc_alpha
	if life > ( LIFE_MAX - 40 ) {
		alpha = ( LIFE_MAX - life ) * 5
	} else {
		alpha = limit( life * 5 , 0, 200 )
	}
	return
//
// W(0, 0, 0)𒆐SɁAXYʏɃO`
*draw_myself
	repeat DIV_NUM
		hsvcolor cnt * 191 / DIV_NUM, 255, 255
		t = 3.14 * 2 * cnt / DIV_NUM + ang
		d3s_x = r * cos( t ), r * cos( t + ANG_WIDTH ), r_inner * cos( t + ANG_WIDTH ), r_inner * cos( t )
		d3s_y = r * sin( t ), r * sin( t + ANG_WIDTH ), r_inner * sin( t + ANG_WIDTH ), r_inner * sin( t )
		d3square d3s_x, d3s_y, d3s_z
	loop
	return
#global
	d3s_z@ring = 0, 0, 0, 0
